test:
  extends:
    - .only-refs-default
  image: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  needs: ["build"]
  stage: test
  variables:
    APPS_H5_DB_HOST: postgres
    APPS_H5_DB_NAME: hifive_test
    APPS_H5_DB_PW: hifive
    APPS_H5_DB_USER: postgres
    APPS_H5_DELIVERY_METHOD: test
    DATABASE_COMMAND: db:migrate
    POSTGRESQL_PASSWORD: hifive
    POSTGRESQL_DATABASE: hifive_test
    RACK_ENV: test
    RAILS_ENV: test
    SELENIUM_URL: http://chrome:4444/wd/hub/
    START_XVFB: "false"
  services:
    - name: selenium/standalone-chrome:3.141
      alias: chrome
    - name: bitnami/postgresql:12.3.0
      alias: postgres
  before_script:
    - apk add build-base yarn # need to build gem extensions, webpacker
    - bundle config set without 'development' # to get test group gems back
    - bundle install
    - yarn install --frozen-lockfile
    - RAILS_ENV=test bundle exec rails webpacker:compile
  script:
    - bundle exec rubocop
    - bundle exec rspec spec
  artifacts:
    reports:
      cobertura: coverage/coverage.xml
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - vendor/bundle
      - node_modules
